# -*- coding: utf-8 -*-
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from .relation import QueryBody


class Table(QueryBody):
    def __init__(self, line=None, pos=None, name=None):
        super(Table, self).__init__(line, pos)
        self.name = name

    def accept(self, visitor, context):
        return visitor.visit_table(self, context)

    def __str__(self):
        return str(self.name)


class TableSubquery(QueryBody):
    def __init__(self, line=None, pos=None, query=None):
        super(TableSubquery, self).__init__(line, pos)
        self.query = query

    def accept(self, visitor, context):
        return visitor.visit_table_subquery(self, context)

    # def __str__(self):
    #     """
    #     return MoreObjects.toStringHelper(this).addValue(query).toString();
    #     """
